%% SKA-LOW receive path gain
%
% The aim of this script is to model the direction-independent gains of the
% analog receive paths in a SKA-LOW station in a realistic way. The model
% implemented in this script is described on the following Confluence page:
%
% https://confluence.skatelescope.org/display/TDT/Signal+Chain+Behavioural+Modeling
%
% Stefan J. Wijnholds, 28 July 2020
% Last modified on 25 January 2021 by Stefan J. Wijnholds

%% clean up old stuff
clear
close all

% simulation parameters
Tavg = 0;           % average temperature (K)
                    % if this value is set to zero, temperature data will
                    % be read from file tempdata.mat
Tampl = 10;         % amplitude of sinusoidal diurnal variations (K)
Lpeak = 1000;       % maximum solar irradiance (W / m^2)
timescale = 100;    % time scale of Gaussian process (s)
spatscale = 35;     % spatial scale of Gaussian proces (m)
Lrms = 50;          % RMS irradiance variation across station (W / m^2)
LFOrms = 10;        % RMS irradiance variation across FO links (W / m^2)

% parameters and (production) tolerances LNAs
dT_LNA = 15;        % raise of temperature inside LNA housing w.r.t. ambient
                    % temperature due to heating by LNA (K)
alphaLNA = 0.01;    % sensitivity to solar irradiation changes (K m^2 / W)
alphaLNA_e = 1e-3;  % RMS variation on alphaLNA (K m^2 / W);
% production tolerances set to 5% level
epsmag_LNA = 0.44;  % RMS gain magnitude variations between receive paths in dB
epsph_LNA = 2.9;    % RMS gain phase variations between receive paths in deg

% parameters and (production) tolerances FEMs
dT_FEM = 10;        % raise of temperature inside SMARTBox housing w.r.t.
                    % ambient temperature due to heating by electronics (K)
alphaFEM = 0.01;    % sensitivity to solar irradiation changes (K m^2 / W)
alphaFEM_e = 1e-3;  % RMS variation of alphaFEM (K m^2 / W);

% parameters and (production) tolerances FOs
alpha_FO = 0.02;    % sensitivity to solar irradiance (in K m^2 / W);
L0FOcable = 5e3;    % nominal length of FO cables (m)
L0FOcable_RMS = 0.1;% RMS variation of FO cable length (m)
% production tolerances set to 5% level
epsmag_FO = 0.44;   % RMS gain magnitude variations between receive paths in dB
epsph_FO = 2.9;     % RMS gain phase variations between receive paths in deg

% collect simulation parameters for storage along with results
params = who;
Nparams = length(params);
attr = cell(2 * (Nparams + 6), 1);
for n = 1:Nparams
    attr{2 * n - 1} = params{n};
    attr{2 * n} = double(eval(params{n}));
end

% .mat file with frequency-dependent FEM production tolerances as generated
% by the script analysis_FEM_data.m
FEM_tol_file = 'tolerances_FEM.mat';

% .mat file with frequency-dependent preADU production tolerances as
% generated by the script analysis_preADU_data.m
preADU_tol_file = 'tolerances_preADU.mat';

% fiducial frequencies (Hz)
f = (50:5:350).' * 1e6;
Nf = length(f);

%% Temperature and solar irradiance model
% It is assumed that gain variations as well as gain difference variations
% are pre-dominantly caused by the diurnal variation in environmental
% temperature and solar irradiance. These are modeled as two sine waves
% that are a quarter period out of phase. These variations are assumed to
% be constant for all trumpets and SMARTboxes in the field.
%
% To assess the impact of potential small variations in temperature or
% solar irradiance on shorter time scales, the script can also generate
% additional, spatially correlated variations based on Gaussian processes.
% These are intended to emulate, for example, the impact of one component
% moving into the shadow of another component.

if Tavg == 0
    % read timestamps and temperature data for ambient temperature and
    % temperature in a SmartBox on AAVS2 from file
    load tempdata.mat
    Nt = length(timestamp);
    t = (timestamp - floor(timestamp(1))) * 24 * 3600;
    % ambient temperature (K)
    T0 = Tamb + 273;
    % solar irradiance (W / m^2)
    L0 = max(0, Lpeak * sin(-pi/2 + 2 * pi * (t / (24 * 3600))));
else
    % model ambient temperature
    % define time axis (s)
    tstart = 0;         % start time, 0 means 0:00 h at night
    tstop = 24 * 3600;  % stop time (excluded from time series)
    Nt = 100;           % number of time slots to emulate
    dt = (tstop - tstart) / Nt;
    t = (0:Nt-1).' * dt;
    % ambient temperature (K)
    T0 = Tavg + Tampl * sin(pi + 2 * pi * (t / (24 * 3600)));
    % solar irradiance (W / m^2)
    L0 = max(0, Lpeak * sin(-pi/2 + 2 * pi * (t / (24 * 3600))));
end

% spatially correlated perturbation of irradiance variation
% load anenna positions
load Arraylayout_DiNinni_SKA-LOW_38m.mat
Nant = size(Arraylayout, 1);

% add dimensions of simulations to attributes
attr{2 * Nparams + 1} = 'Nant';
attr{2 * Nparams + 2} = int32(Nant);
attr{2 * Nparams + 3} = 'Nf';
attr{2 * Nparams + 4} = int32(Nf);
attr{2 * Nparams + 5} = 'Nt';
attr{2 * Nparams + 6} = int32(Nt);

attr{2 * Nparams + 7} = 'dim_Nant';
attr{2 * Nparams + 8} = int32(1);
attr{2 * Nparams + 9} = 'dim_Nf';
attr{2 * Nparams + 10} = int32(2);
attr{2 * Nparams + 11} = 'dim_Nt';
attr{2 * Nparams + 12} = int32(3);

% Groups of 16 antennas are connected to the same SMARTBox and, hence, the
% temperature variations experiences by the FEMs within a group will be
% very similar. In this initial simulation, it will be assumed that the
% SMARTBoxes are placed 15m from the center of the array in a circular
% configuration and that each SMARTBox is connected to a group of 16
% antennas covering a specific azimuth range. This model can be replaced by
% the mapping of an actual station later on.
% azimuthal angle of antennas
phi = atan2(Arraylayout(:, 1), Arraylayout(:, 2));
[phi_sorted, sortidx] = sort(phi);  % sorted azimuthal angles
SBpos = zeros(Nant, 2);             % positions of SMARTBoxes in m
for idx = 1:16:Nant
    SBpos(sortidx(idx:idx+15), 1) = 15 * cos(mean(phi_sorted(idx:idx+15)));
    SBpos(sortidx(idx:idx+15), 2) = 15 * sin(mean(phi_sorted(idx:idx+15)));
end

% Generate smoothed time series indepedently for each receive path as joint
% generation for all receive paths and timeslots results in a prohibitively
% large kernel. Note that each receive path gets a perturbed temperature at
% two locations: the trumpet and the SMARTbox.
% generator function: Gaussian process with squared exponential kernel
d_time = toeplitz(0:Nt-1);
% exponent chosen <2 to avoid degeneration
K_time = exp(-d_time.^1.9999 / timescale^2);
[v, d] = eig(K_time);
Rt = v * sqrt(d) / v;
X = randn(Nt, 2 * Nant);
Xt = Rt * X;

% generate solar irradiance variations with spatial constraint
% generator function: Gaussian process with squared exponential kernel
pos = [Arraylayout; SBpos];
d_spatial = sqrt((meshgrid(pos(:, 1)) - meshgrid(pos(:, 1)).').^2 + ...
                 (meshgrid(pos(:, 2)) - meshgrid(pos(:, 2)).').^2);
% exponent chosen <2 to avoid degeneration
K_spatial = exp(-d_spatial.^1.9999/ spatscale^2);
[v, d] = eig(K_spatial);
Rs = v * sqrt(d) / v;
dL = real(Rs * Xt.');
% normalize to desired level of variation
stdL = std(dL);
dL = (Lrms / max(stdL)) * dL * diag((L0 / max(L0)));
% split in perturbations at trumpet and perturbations at SMARTBox
dLLNA = dL(1:Nant, :);
dLSB = dL(Nant+1:end, :);

%% LNA gain model

% LNA temperature model
TLNA = repmat(T0.', [Nant, 1]) + dT_LNA + ...
       diag(alphaLNA + alphaLNA_e * randn(Nant, 1)) * (repmat(L0.', [Nant, 1]) + dLLNA);

% dyn_scatter_plot(Arraylayout, TLNA, 5, 'LNA temperature');

% generate LNA gains
[gLNAx, gLNAy] = gen_gLNA(f, epsmag_LNA, epsph_LNA, TLNA);

% dyn_scatter_plot(Arraylayout, angle(squeeze(gLNA(:, 1, :))) * 180 / pi, 5, 'LNA phase (deg)');
% dyn_scatter_plot(Arraylayout, 20 * log10(abs(squeeze(gLNA(:, 1, :)))), 5, 'LNA gain (dB)');

%% FEM gain model

% FEM temperature model
if Tavg == 0
    % Measured SmartBox temperature curve has been read from file.
    % This includes the effects of ambient temperature, heating and solar
    % irradiation.
    Tnominal = TSB + 273;
    % Introduce small differences in sensitivity to solar irradiation
    dTFEM = alphaFEM_e * randn(Nant, 1) * L0.';
    TFEM = repmat(Tnominal.', [Nant, 1]) + dTFEM;
else
    % generate temperature curves based on model
    TFEM = repmat(T0.', [Nant, 1]) + dT_FEM + ...
                  diag(alphaFEM + alphaFEM_e * randn(Nant, 1)) * (repmat(L0.', [Nant, 1]) + dLSB);
end

% dyn_scatter_plot(Arraylayout, TFEM, 5, 'FEM temperature');

% generate FEM gains
[gFEMx, gFEMy] = gen_gFEM(f, FEM_tol_file, TFEM);

% dyn_scatter_plot(Arraylayout, angle(squeeze(gFEMx(:, 1, :))) * 180 / pi, 5, 'FEM phase (deg)');

% dyn_scatter_plot(Arraylayout, 20 * log10(abs(squeeze(gFEMx(:, 1, :)))), 5, 'FEM gain (dB)');

%% RFoF gain model

% It is assumed that all fiber links for a single station are tied together
% in a single string or even a single multi-fiber cable. We therefore
% assume a much lower variation in irradiance between receive paths than
% before.
d_time = toeplitz(0:Nt-1);
% exponent chosen <2 to avoid degeneration
K_time = exp(-d_time.^1.9999 / timescale^2);
[v, d] = eig(K_time);
Rt = v * sqrt(d) / v;
X = randn(Nt, Nant);
dLFO = real(Rt * X);
% normalize to desired level of variation
stdL = std(dLFO);
dLFO = (LFOrms / max(stdL)) * dLFO.' * diag(L0 / max(L0));
% compute total irradiance
LFO = repmat(L0.', [Nant, 1]) + dLFO;

% compute temperature
TFO = repmat(T0.', [Nant, 1]) + alpha_FO * LFO;

% length of FO cables (m)
L0FO = L0FOcable + L0FOcable_RMS * randn(Nant, 1);

% generate RFoF gains
[gFOx, gFOy] = gen_gFO(f, epsmag_FO, epsph_FO, L0FO, TFO);

% dyn_scatter_plot(Arraylayout, angle(squeeze(gFOx(:, 1, :))) * 180 / pi, 5, 'RFoF phase (deg)');

%% pre-ADU gain model
[g_preADUx, g_preADUy] = gen_g_preADU(f, preADU_tol_file, Nant);

% Replicate static model to match size of gain tensors for other components
g_preADUx = repmat(g_preADUx, [1, 1, Nt]);
g_preADUy = repmat(g_preADUy, [1, 1, Nt]);

%% calculate overall gain
g_totx = gLNAx .* gFEMx .* gFOx .* g_preADUx;
g_toty = gLNAy .* gFEMy .* gFOy .* g_preADUy;

% dyn_scatter_plot(Arraylayout, angle(squeeze(g_totx(:, 6, :))) * 180 / pi, 1, 'overall phase (deg)');

% collect time and frequency axes and simulated gains for storage
datasets = {'time (s)', t, 'freq (Hz)', f, ...
            'gain_xpol', g_totx, 'gain_ypol', g_toty};

% store results in HDF5 format
filename = 'test.h5';
h5write_all(filename, attr, datasets);

